image: docker:latest
services:
  - docker:dind

stages:
  - sast
  - report
  - build_develop
  - build_latest
  - build_tag
  - sast_latest
  - report_latest
     
sast:
  stage: sast
  script:
    - cd src && docker run --rm -v "${PWD}:/src" returntocorp/semgrep --config=p/security-audit --json > gl-sast-report.json
  artifacts:
    paths:
      - src/gl-sast-report.json  
    reports:
       sast: src/gl-sast-report.json      
  except:
    - schedules
    - tags
    
report:
  stage: report
  image: dwdraju/alpine-curl-jq
  needs: ["sast"]
  when: on_success
  script:  
    - if $(cat src/gl-sast-report.json | jq [.] | jq .[] | jq '[.results[].extra.severity|contains("WARNING")] | any'); then exit 1; fi
    - if $(cat src/gl-sast-report.json | jq [.] | jq .[] | jq '[.results[].extra.severity|contains("ERROR")] | any'); then exit 1; fi
  except:
    - schedules
    - tags    

build_develop:
  stage: build_develop
  needs: ["report"]
  when: always
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  script:
    - docker build -t $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:develop .
    - docker push $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:develop
  except:
    - tags
    - schedules

build_latest:
  needs: 
    - "report" 
    - "build_develop"
  when: on_success
  stage: build_latest
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  script:
    - docker build -t $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:latest .
    - docker push $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:latest
  except:
    - tags
    - schedules
    - tags
    
build_tag:
  stage: build_tag
  before_script:
    -  docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  script:
    - echo $CI_COMMIT_TAG 
    - docker build -t $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:$CI_COMMIT_TAG .
    - docker push $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:$CI_COMMIT_TAG
  only:
    - tags
    
sast_latest:
  stage: sast_latest
  before_script:
    - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  script:
    - docker pull $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:latest
    - docker create --name="tmp_$$" $CI_REGISTRY/y.koretskyi/$CI_PROJECT_NAME:latest
    - docker export tmp_$$ > latest.tar && tar -xvf latest.tar app && cd app
    - docker run --rm -v "${PWD}:/src" returntocorp/semgrep --config=p/security-audit --json > gl-sast-report.json
  artifacts:
    paths:
      - app/gl-sast-report.json
    reports:
       sast: app/gl-sast-report.json   
  only:
    - schedules
    
report_latest:
  stage: report_latest
  image: dwdraju/alpine-curl-jq
  needs: ["sast_latest"]
  when: on_success
  script: 
    - if $(cat app/gl-sast-report.json | jq [.] | jq .[] | jq '[.results[].extra.severity|contains("WARNING")] | any'); then exit 1; fi
    - if $(cat app/gl-sast-report.json | jq [.] | jq .[] | jq '[.results[].extra.severity|contains("ERROR")] | any'); then exit 1; fi
  only:
    - schedules
